join channels on login, so when bot reconnects it will rejoin channels

TODO: it sends more than one JOIN #channel command on login events, could cause
flood, but at least solves case when gets timeouts

--- bot.php	2005-06-25 23:13:53.000000000 +0300
+++ ./misc/irc/bot.php	2005-06-25 23:22:28.000000000 +0300
@@ -258,6 +258,14 @@
         return $channels[$prj_id];
     }
     
+
+    function _joinChannels(&$irc)
+    {
+        foreach ($GLOBALS['channels'] as $prj_id => $channel_list) {
+            $irc->join($channel_list);
+        }
+    }
+
     
     /**
      * Helper method to the projects a channel displays messages for.
@@ -367,12 +375,16 @@
 $irc->setLogdestination(SMARTIRC_FILE);
 $irc->setLogfile(APP_IRC_LOG);
 $irc->setUseSockets(TRUE);
-$irc->setAutoReconnect(FALSE);
+$irc->setAutoReconnect(TRUE);
 $irc->setAutoRetry(TRUE);
+$irc->setReceiveTimeout(600);
+$irc->setTransmitTimeout(600);
 
 // register saytime() to be called every 30 sec. (30,000 milliseconds)
 $irc->registerTimehandler(3000, $bot, 'notifyEvents');
 
+$irc->registerActionhandler(SMARTIRC_TYPE_LOGIN, '.*', $bot, '_joinChannels');
+
 // methods that keep track of who is authenticated
 $irc->registerActionhandler(SMARTIRC_TYPE_QUERY, '^!?list-auth', $bot, 'listAuthenticatedUsers');
 $irc->registerActionhandler(SMARTIRC_TYPE_NICKCHANGE, '.*', $bot, '_updateAuthenticatedUser');
@@ -387,12 +399,9 @@
 
 $irc->connect($irc_host, $irc_port);
 $irc->login($irc_nick, $irc_realname, 0, $irc_username, $irc_password);
-foreach ($channels as $prj_id => $channel_list) {
-    $irc->join($channel_list);
-}
 $irc->listen();
 $irc->disconnect();
 
 // release the lock
 Lock::release('irc_bot');
-?>
\ No newline at end of file
+?>
